#include <stdio.h>

#define R 100
#define S 10000
#define U 100

struct utente_s 
{
	int uid; // universal id
			 // ~"smart": id coincide con posizione nell'array
			 // degli utenti del server
	char nome[30];
	char cognome[40];
};
typedef struct utente_s utente;

struct risposta_s 
{
	int uid;
	char contenuto_risposta[1000];
	int num_like;
	int num_dislike;
	utente user;	// l'utente che ha scritto la risposta
};
typedef struct risposta_s risposta;

struct spottata_s 
{
	int uid;
	char contenuto_spottata[1000];
	utente mittente;
	risposta risposte[R];
	int numero_risposte_effettive;
};
typedef spottata_s spottata;

struct server_s 
{
	spottata spottate[S];
	utente utenti[U];
	int numero_spottate_effettive;
	int numero_utenti_effettivi;
	int numero_risposte_totali;
};
typedef struct server_s server;

int main() 
{
	// l'operazione scelta
	char operazione;

	// strutture temporanee, vedi sotto
	spottata temp_s;
	utente temp_u;
	risposta temp_r;

	// il server
	server s;
	s.numero_spottate_effettive = 0;
	s.numero_utenti_effettivi = 0;
	s.numero_risposte_totali = 0;

	// varie
	int num_spottata, trovato, i, j;

	do 
	{
		printf("Inserire un valore corretto\n");
		scanf("%c", &operazione);
		switch (operazione)
		{
			case 'u':
				printf("Inserire nome utente\n");
				scanf("%s", temp_u.nome);
				printf("Inserire cognome utente\n");
				scanf("%s", temp_u.cognome);
				temp_u.uid = s.numero_utenti_effettivi;
				s.utenti[s.numero_utenti_effettivi] = temp_u;
				s.numero_utenti_effettivi++;
				break;
			case 'i':
				printf("Inserire testo spottata\n");
				scanf("%s", temp_s.contenuto_spottata);
				printf("Inserire lo uid del mittente\n");
				scanf("%d", &(temp_u.uid));
				for (i=0, trovato=0; i<s.numero_utenti_effettivi && trovato != 1; i++)
					if (temp_u.uid == s.utenti[i].uid)
					{
						temp_u = s.utenti[i];
						trovato=1;
					}
				if(trovato != 1)
				{
					printf("Non c'e' lo uid inserito\n");
					break;
				}
				temp_s.mittente = temp_u;
				temp_s.numero_risposte_effettive = 0;
				temp_s.uid = s.numero_spottate_effettive;
				s.spottate[s.numero_spottate_effettive] = temp_s;
				s.numero_spottate_effettive++;
				break;
			case 'v':
				printf("Inserire numero spottata\n");
				scanf("%d", &num_spottata);
				for (i=0, trovato=0; i<s.numero_spottate_effettive && trovato!=1; i++)
					if (s.spottate[i].uid == num_spottata)
					{
						printf("%s\n",s.spottate[i].contenuto_spottata);
						printf("Scritto da %s %s\n", s.spottate[i].mittente.nome, s.spottate[i].mittente.cognome)
						for (j=0; j<s.spottate[i].num_risposte_effettive; j++)
						{
							printf("%s\n",s.spottate[i].risposta[j].contenuto_risposta);
							printf("Scritto da %s %s\n", s.spottate[i].risposta[j].user.nome, s.spottate[i].risposta[j].user.nome);
						}
						trovato = 1;
					}
					if (trovato == 0)
						printf("Spottata non trovata\n");
				break;
			case 'r':
				printf("Inserire numero spottata\n");
				scanf("%d", &num_spottata);
				for (i=0, trovato=0; i<s.numero_spottate_effettive && trovato!=1; i++)
				{
					if (s.spottate[i].uid == num_spottata)
					{
						printf("Inserire lo uid del mittente\n");
						scanf("%d", &(temp_u.uid));
						for (i=0, trovato=0; i<s.numero_utenti_effettivi && trovato != 1; i++)
						{
							if (temp_u.uid == s.utenti[i].uid)
							{
								temp_u = s.utenti[i];
								trovato=1;
							}
						}
						if(trovato != 1)
						{
							printf("Non c'e' lo uid inserito\n");
							break;
						}
						temp_r.user=temp_u;
						printf ("Inserisci la risposta\n");
						scanf ("%s", temp_r.contenuto_risposta);
						temp_r.like=0;
						temp_r.dislike=0;
						temp_r.uid = s.numero_risposte_totali;
						s.spottate[i].risposte[s.spottate[i].numero_risposte_effettive]=temp_r;
						s.spottate[i].numero_risposte_effettive++;
						s.numero_risposte_totali++;
					}
				}
				if (trovato == 0)
					printf("Spottata o utente non trovata/o\n");
				break;
			case 't':
				// per ogni utente predisponi un punteggio
				// per ogni spottata
				// cerca le rispsote
				// e fai like - dislike
				// salva il punteggio
				// (hint: il punteggio si trova in una cella di una array, spiazzato con lo uid dell'utente)
				for (i=0, trovato=0; i<s.numero_utenti_effettivi && trovato != 1; i++)
				{

				}
				break;
			case 's':
				// per ogni spottata
				// prendi il suo messaggio
				// cerca le rispsote
				// applica funzione / funzione
				break;
			default:
				printf("Inserire un valore corretto\n");
		}
	} while 
	return 0;
}